#
#
# =================================================================
# Licensed Materials - Property of IBM
#
# (c) Copyright IBM Corp. 2013, 2014 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# =================================================================

import gettext
import os
import six

from powervc_cinder.k2aclient.openstack.common.gettextutils import Message
from powervc_cinder.k2aclient.openstack.common.gettextutils import USE_LAZY

#
# The following code overrides _ to retrieve translated messages from
# powervc_cinder message catalogs (default in /usr/share/locale/<locale>)
#
_localedir = os.environ.get('powervc_cinder'.upper() + '_LOCALEDIR')
_t = gettext.translation('powervc_cinder', localedir=_localedir, fallback=True)


def _(msg):
    if USE_LAZY:
        return Message(msg, domain='powervc_cinder')
    else:
        if six.PY3:
            return _t.gettext(msg)
        return _t.ugettext(msg)
