#
#
# =================================================================
# Licensed Materials - Property of IBM
#
# (c) Copyright IBM Corp. 2013, 2015 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# =================================================================

"""
PowerVC Extension to the Manager for the Cinder Scheduler Service
"""

from oslo_log import log as logging
from cinder.scheduler import manager as schedmgr

LOG = logging.getLogger(__name__)


class PowerVCSchedulerManager(schedmgr.SchedulerManager):
    """PowerVC extension to the Cinder Scheduler Manager."""

    def __init__(self, scheduler_driver=None, *args, **kwargs):
        super(PowerVCSchedulerManager, self).__init__(scheduler_driver,
                                                      *args, **kwargs)

    def get_all_host_states(self, context):
        """Returns a dict of all the hosts the HostManager knows about."""
        output_map = {}
        host_states = self.driver.host_manager.get_all_host_states(context)
        for item in host_states:
            output_map[item.host] = {
                'free_capacity_gb': item.free_capacity_gb,
                'total_capacity_gb': item.total_capacity_gb
            }
        return output_map
