# =================================================================
# Licensed Materials - Property of IBM
#
# (c) Copyright IBM Corp. 2015 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# =================================================================

from oslo_log import log as logging
from cinder.i18n import _LI
from cinder.volume.drivers.ibm.storwize_svc import ssh


class PowerVCStorwizeSSH(ssh.StorwizeSSH):

    def __init__(self, run_ssh):
        super(PowerVCStorwizeSSH, self).__init__(run_ssh)

    def mkvdiskhostmap(self, host, vdisk, lun, multihostmap):
        """Map vdisk to host.

        Always use the force flag ... cause we can!!!!!!
        """
        ssh_cmd = ['svctask', 'mkvdiskhostmap', '-force',
                   '-host', '"%s"' % host, '-scsi', lun, vdisk]

        return self.run_ssh_check_created(ssh_cmd)
