#
#
# =================================================================
# Licensed Materials - Property of IBM
#
# (c) Copyright IBM Corp. 2013, 2014 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# =================================================================

from __future__ import print_function
import tools.k2aclient.k2asample as k2asample
from powervc_cinder.k2aclient import client

import logging


def ssp_lu_clone_simple(cs, cluster_id):
    """lu_clone sample for k2aclient"""

    # CREATE SOURCE
    cluster = cs.cluster.get(cluster_id)
    n = cs.sharedstoragepool.create_unique_name
    (status, source_udid, job_id) = cluster.lu_create(n("P2Z-SOURCE-DM"), 10)
    print ("lu_create job >%s< for SOURCE completed w/ status: >%s<" %
           (job_id, status))

    # CREATE TARGET
    cluster = cs.cluster.get(cluster_id)
    n = cs.sharedstoragepool.create_unique_name
    (status, target_udid, job_id) = cluster.lu_create(n("P2Z-TARGET-DM"), 10)
    print ("lu_create job >%s< for TARGET completed w/ status: >%s<" %
           (job_id, status))

    # CLONE
    status, job_id = cluster.lu_linked_clone(
        source_udid,
        target_udid)

    print ("lu_linked_clone job: >%s<, completed w/ status: >%s<" %
           (job_id, status,))

#     # DELETE BY UPDATE
#     ssp_id = cluster.sharedstoragepool_id()
#     ssp = cs.sharedstoragepool.get(ssp_id)
#     ssp = ssp.update_del_lus([source_udid,
#                               target_udid])

    # DELETE BY JOB
    cluster.lu_delete(source_udid)
    cluster.lu_delete(target_udid)

    print ("Deleted Source LU: >%s< and Target LU: >%s<" %
           (source_udid, target_udid))

if __name__ == '__main__':

    k2acfg = k2asample.getk2acfg()
    k2asample.configure_logging(logging.getLevelName(k2acfg['loglevel']))
#     cs = client.Client(k2acfg['api_version'],
#                        "9.114.181.229",  # k2acfg['k2_url'],
#                        k2acfg['k2_username'],
#                        "Passw0rd",  # k2acfg['k2_password'],
#                        k2_auditmemento=k2acfg['k2_auditmemento'],
#                        k2_certpath=k2acfg['k2_certpath'],
#                        retries=k2acfg['retries'],
#                        timeout=k2acfg['timeout'],
#                        excdir=k2acfg['excdir'])

#     # gerald 168
#     k2_url = "9.114.181.168"
#     k2_password = "passw0rd"
#     cluster_id = "02803f50-7063-3602-a304-fb54e4ca2d44"  # p730_810_A

#     # gerald_225
#     k2_url = "9.114.181.225"
#     k2_password = "Passw0rd"
# #     cluster_id = "04628d39-67df-3047-b90e-c4d9b4057267"  # p730_810_A
#     cluster_id = "f598ac8f-c644-36c0-8a4c-1c58809527e0"  # p730_810_B

#     # Gerald
#     k2_url = "9.114.181.238"
#     k2_password = "Passw0rd"
#     cluster_id = "04628d39-67df-3047-b90e-c4d9b4057267"  # carl's new cluster

# #     REJY
#     k2_url = "9.126.139.241"
#     k2_password = k2acfg['k2_password']
#     cluster_id = "c43fbdcd-95f2-3b4a-b643-234ff00eded4"  # TestCluster

# #     N8
#     k2_url = "hmc4.watson.ibm.com"
#     k2_password = k2acfg['k2_password']
#     cluster_id = "0c737495-d09a-337a-a7e9-6173d4bb6d20"  # cluster-c

#     # N7
#     k2_url = "hmc4.watson.ibm.com"
#     k2_password = k2acfg['k2_password']
#     cluster_id = "fe3fbe0f-5ba8-3374-ab75-7b653c9a57ff"  # cluster-b

#     # N3
#     k2_url = "hmc4.watson.ibm.com"
#     k2_password = k2acfg['k2_password']
# #     cluster_id = "fe3fbe0f-5ba8-3374-ab75-7b653c9a57ff"  # cluster-b
#     cluster_id = "8869b443-6566-3184-adfc-066ffb53d0a6"  # cluster-s

    # GFM's 4Q2014 Dev machine
    k2_url = "9.114.181.168"
    k2_password = "passw0rd"
    cluster_id = "6f9f0540-d547-32a9-ba3a-ee70d1d81fc8"  # powervc_demo_cluster

    cs = client.Client(k2acfg['api_version'],
                       k2_url,  # k2acfg['k2_url'],
                       k2acfg['k2_username'],
                       k2_password,  # k2acfg['k2_password'],
                       k2_auditmemento=k2acfg['k2_auditmemento'],
                       k2_certpath=k2acfg['k2_certpath'],
                       retries=k2acfg['retries'],
                       timeout=k2acfg['timeout'],
                       excdir=k2acfg['excdir'])

    # sde-power clustercd79f607-671e-3a80-9862-63d48702729e
#     cluster_id = 'c38db666-ba8c-35d0-9fa6-d2bf0cc5ea4b'  # cluster-e
#     cluster_id = '6a948d4c-000f-3219-8972-818c37a94d97'  # cluster-d
#     cluster_id = 'cd79f607-671e-3a80-9862-63d48702729e'  # carl's cluster
#     cluster_id = "ea1b0b5f-3b3a-39dc-bade-6e9cebd18bb2"  # cluster-a
    try:
        ssp_lu_clone_simple(cs, cluster_id)
    except Exception as e:
        logging.exception(e)
